"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultCommand = exports.commandsMap = exports.availableCommandsList = exports.aliases = exports.commands = void 0;

var _generate = _interopRequireDefault(require("./generate"));

var _help = _interopRequireDefault(require("./help"));

var _init = _interopRequireDefault(require("./init"));

var _run = _interopRequireDefault(require("./run"));

var _commandsMap;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var commands = {
  GENERATE: 'generate',
  HELP: 'help',
  INIT: 'init',
  RUN: 'run'
};
exports.commands = commands;
var aliases = {
  g: commands.GENERATE,
  h: commands.HELP
};
exports.aliases = aliases;
var availableCommandsList = [null].concat(_toConsumableArray(Object.values(commands)), _toConsumableArray(Object.keys(aliases)));
exports.availableCommandsList = availableCommandsList;
var commandsMap = (_commandsMap = {}, _defineProperty(_commandsMap, commands.GENERATE, _generate["default"]), _defineProperty(_commandsMap, commands.HELP, _help["default"]), _defineProperty(_commandsMap, commands.INIT, _init["default"]), _defineProperty(_commandsMap, commands.RUN, _run["default"]), _commandsMap);
exports.commandsMap = commandsMap;
var defaultCommand = commands.HELP;
exports.defaultCommand = defaultCommand;