"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _chalk = _interopRequireDefault(require("chalk"));

var _baseLogger = _interopRequireDefault(require("../../utils/base-logger"));

var _core = require("../../core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var InstallerLogger =
/*#__PURE__*/
function (_BaseLogger) {
  _inherits(InstallerLogger, _BaseLogger);

  function InstallerLogger() {
    _classCallCheck(this, InstallerLogger);

    return _possibleConstructorReturn(this, _getPrototypeOf(InstallerLogger).apply(this, arguments));
  }

  _createClass(InstallerLogger, [{
    key: "next",
    value: function next(_ref) {
      var type = _ref.type,
          payload = _ref.payload;

      switch (type) {
        case _core.Installer.operations.WRITE_USER_GENERETOR_CONFIG_SUCCESS:
          console.log("".concat(_chalk["default"].green('UPDATED'), " package.json"));
          break;

        case _core.Installer.operations.CREATE_CUSTOM_SEEDER_TEMPLATE_FILE_SKIP_FILE_EXISTS:
          console.log("".concat(_chalk["default"].yellow('SKIP'), " ").concat(payload.customSeederTemplateFilename, " are already exists"));
          break;

        case _core.Installer.operations.CREATE_CUSTOM_SEEDER_TEMPLATE_FILE_SUCCESS:
          console.log("".concat(_chalk["default"].green('CREATED'), " ").concat(payload.customSeederTemplateFilename));
          break;

        case _core.Installer.operations.CREATE_SEEDERS_FOLDER_SKIP_FOLDER_EXISTS:
          console.log("".concat(_chalk["default"].yellow('SKIP'), " ").concat(payload.foldername, " are already exists"));
          break;

        case _core.Installer.operations.CREATE_SEEDERS_FOLDER_SUCCESS:
          console.log("".concat(_chalk["default"].green('CREATED'), " ").concat(payload.foldername));
          break;

        case _core.Installer.operations.WRITE_USER_CONFIG_SKIP_FILE_EXISTS:
          console.log("".concat(_chalk["default"].yellow('SKIP'), " ").concat(payload.filename, " are already exists"));
          break;

        case _core.Installer.operations.WRITE_USER_CONFIG_SUCCESS:
          console.log("".concat(_chalk["default"].green('CREATED'), " ").concat(payload.filename));
          break;
      }
    }
  }, {
    key: "error",
    value: function error(_ref2) {
      var type = _ref2.type,
          payload = _ref2.payload;

      switch (type) {
        case _core.Installer.operations.WRITE_USER_GENERETOR_CONFIG_ERROR:
          console.log("".concat(_chalk["default"].red('ERROR'), " Unable to write config file: ").concat(_chalk["default"].gray(payload.filepath)));
          break;

        case _core.Installer.operations.CREATE_CUSTOM_SEEDER_TEMPLATE_FILE_ERROR:
          console.log("".concat(_chalk["default"].red('ERROR'), " Unable to create custom seeder template: ").concat(_chalk["default"].gray(payload.customSeederTemplatePath)));
          break;

        case _core.Installer.operations.CREATE_SEEDERS_FOLDER_ERROR:
          console.log("".concat(_chalk["default"].red('ERROR'), " Unable to create seeders folder: ").concat(_chalk["default"].gray(payload.folderpath)));
          break;

        case _core.Installer.operations.WRITE_USER_CONFIG_ERROR:
          console.log("".concat(_chalk["default"].red('ERROR'), " Unable to write user config file: ").concat(_chalk["default"].gray(payload.filepath)));
          break;
      }

      if (payload && payload.error) console.error(payload.error);
    }
  }]);

  return InstallerLogger;
}(_baseLogger["default"]);

exports["default"] = InstallerLogger;