"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _chalk = _interopRequireDefault(require("chalk"));

var _logSymbols = _interopRequireDefault(require("log-symbols"));

var _clui = require("clui");

var _baseLogger = _interopRequireDefault(require("../../utils/base-logger"));

var _core = require("../../core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var RunLogger =
/*#__PURE__*/
function (_BaseLogger) {
  _inherits(RunLogger, _BaseLogger);

  function RunLogger() {
    var _this;

    _classCallCheck(this, RunLogger);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RunLogger).call(this));
    _this.spinner = new _clui.Spinner();
    return _this;
  }

  _createClass(RunLogger, [{
    key: "next",
    value: function next(_ref) {
      var type = _ref.type,
          payload = _ref.payload;
      this.spinner.stop();

      switch (type) {
        case _core.MdSeedRunner.operations.MONGOOSE_CONNECT_START:
          this.spinner.message('Trying to connect to MongoDB...');
          this.spinner.start();
          break;

        case _core.MdSeedRunner.operations.MONGOOSE_CONNECT_SUCCESS:
          console.log("".concat(_logSymbols["default"].success, " Successfully connected to MongoDB!"));
          break;

        case _core.MdSeedRunner.operations.MONGOOSE_DROP_START:
          this.spinner.message('Droping database...');
          this.spinner.start();
          break;

        case _core.MdSeedRunner.operations.MONGOOSE_DROP_SUCCESS:
          console.log("".concat(_logSymbols["default"].success, " Database dropped!"));
          break;

        case _core.MdSeedRunner.operations.ALL_SEEDERS_START:
          console.log();
          console.log("".concat(_chalk["default"].cyan('Seeding Results:')));
          break;

        case _core.MdSeedRunner.operations.ALL_SEEDERS_FINISH:
          console.log();
          console.log("".concat(_logSymbols["default"].success, " Done."));
          break;

        case _core.MdSeedRunner.operations.SEEDER_START:
          this.spinner.message(payload.name);
          this.spinner.start();
          break;

        case _core.MdSeedRunner.operations.SEEDER_SUCCESS:
          if (payload.results && payload.results.run) {
            console.log("".concat(_logSymbols["default"].success, " ").concat(payload.name, ": ").concat(_chalk["default"].gray(payload.results.created)));
          } else {
            console.log("".concat(_chalk["default"].gray('-'), " ").concat(payload.name, ": ").concat(_chalk["default"].gray(0)));
          }

          break;
      }
    }
  }, {
    key: "error",
    value: function error(_ref2) {
      var type = _ref2.type,
          payload = _ref2.payload;
      this.spinner.stop();

      switch (type) {
        case _core.MdSeedRunner.operations.MONGOOSE_CONNECT_ERROR:
          console.log("".concat(_logSymbols["default"].error, " Unable to connected to MongoDB!"));
          break;

        case _core.MdSeedRunner.operations.MONGOOSE_DROP_ERROR:
          console.log("".concat(_logSymbols["default"].error, " Unable to drop database!"));
          break;

        case _core.MdSeedRunner.operations.SEEDER_ERROR:
          console.log("".concat(_logSymbols["default"].error, " ").concat(payload.name));
          break;
      }

      if (payload && payload.error) console.error(payload.error);
    }
  }]);

  return RunLogger;
}(_baseLogger["default"]);

exports["default"] = RunLogger;