"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _commandLineUsage = _interopRequireDefault(require("command-line-usage"));

var _optionDefinitions = _interopRequireDefault(require("./option-definitions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var usageGuide = (0, _commandLineUsage["default"])([{
  header: 'Seed runner',
  content: 'Seed data into the database'
}, {
  header: 'Synopsis',
  content: ['$ md-seed run [{bold --dropdb}] [{bold --seeders} {underline seeder} ...]', '$ md-seed run {bold --help}']
}, {
  header: 'Options',
  optionList: _optionDefinitions["default"]
}, {
  header: 'Examples',
  content: "{bold 1. Run all seeders:}\n      $ md-seed run\n\n      {bold 2. Run selected seeders:}\n      $ md-seed run {bold --seeders} {underline User} {underline Settings}\n      {italic  or}\n      $ md-seed run {bold -s} {underline User} {underline Settings}\n      {italic  or}\n      $ md-seed run {underline User} {underline Settings}\n\n      {bold 3. Drop database and run all seeders:}\n      $ md-seed run {bold --dropdb}\n      {italic  or}\n      $ md-seed run {bold -d}\n\n      {bold 4. Drop database and run selected seeders:}\n      $ md-seed run {underline User} {underline Settings} {bold --dropdb}\n      {italic   or}\n      $ md-seed run {underline User} {underline Settings} {bold -d}\n      "
}]);
var _default = usageGuide;
exports["default"] = _default;