# Snapshot report for `src/e2e/generate.e2e.js`

The actual snapshot is saved in `generate.e2e.js.snap`.

Generated by [AVA](https://ava.li).

## md-seed generate --help

> Snapshot 1

    `␊
    [4m[1mGenerate Seeder[22m[24m␊
    ␊
      Generate new seeder file into the seeder folder. ␊
    ␊
    [4m[1mSynopsis[22m[24m␊
    ␊
      $ md-seed generate [4mseeder-name[24m ␊
      $ md-seed g [4mseeder-name[24m        ␊
      $ md-seed g [1m--help[22m             ␊
    ␊
    [4m[1mOptions[22m[24m␊
    ␊
      [1m-n[22m, [1m--name[22m name   Seeder name to generate ␊
      [1m-h[22m, [1m--help[22m        Show usage guide        ␊
    `

## md-seed generate some-seeder

> log results

    [
      [
        '[32mCREATED[39m seeders/some-name.seeder.js',
      ],
    ]

> sandbox content

    [
      {
        content: [
          {
            content: `import { Seeder } from 'mongoose-data-seed';␊
            import { Model } from '../server/models';␊
            ␊
            const data = [{␊
            ␊
            }];␊
            ␊
            class SomeNameSeeder extends Seeder {␊
            ␊
              async shouldRun() {␊
                return Model.countDocuments().exec().then(count => count === 0);␊
              }␊
            ␊
              async run() {␊
                return Model.create(data);␊
              }␊
            }␊
            ␊
            export default SomeNameSeeder;␊
            `,
            name: 'some-name.seeder.js',
          },
        ],
        name: 'seeders',
      },
    ]

## md-seed generate some-seeder (fail without md-seed-config.js)

> Snapshot 1

    'Must contain md-seed-config.js at the project root. run `md-seed init` to create the config file.'

## md-seed generate some-seeder with custom template and seeders folder

> log results

    [
      [
        '[32mCREATED[39m my-custom-seeders-folder/some-name.seeder.js',
      ],
    ]

> sandbox content

    [
      {
        content: `<% const message = `I am ${seederName} and I created by a custom seeder template.`; %>␊
        console.log('<%= message %>');␊
        `,
        name: 'custom-seeder-template.ejs',
      },
      {
        content: [
          {
            content: `␊
            console.log('I am SomeName and I created by a custom seeder template.');␊
            `,
            name: 'some-name.seeder.js',
          },
        ],
        name: 'my-custom-seeders-folder',
      },
    ]
